Index: branches/encoders/code/projects/libdragonfly/time.c
===================================================================
--- branches/encoders/code/projects/libdragonfly/time.c	(revision 1344)
+++ branches/encoders/code/projects/libdragonfly/time.c	(revision 1345)
@@ -1,28 +1,59 @@
+/**
+ * Copyright (c) 2007 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+
+/**
+ * @file time.c
+ * @brief Timer code
+ *
+ * Implementation of functions for timers.
+ *
+ * @author Colony Project, CMU Robotics Club
+ **/
+
 /*
-time.c
-anything that requires a delay
-mostly delay_ms
+  time.c
+  anything that requires a delay
+  mostly delay_ms
 
-author: Robotics Club, Colony Project
+  author: Robotics Club, Colony Project
 
-Change Log:
-	2.5.07 - Kevin
-		Aaron fixed the orb/servo code and made them use timer3 but compare registers B and C. He hard set the prescaler
-		to 8 so the RTC broke. Changed it so that we use a 8 prescaler which sets the compare match at 1/16th of a second.
-		You now count how many 16ths of a second you want until you trigger your actual interrupt. Works. Changed defines
-		for time so you can still call rtc_init with a scale but now it is defined in terms of actual time like second, quarter_second
-		etc. Read that section in the time.h file for more information. Tested and works, though the clock drifts more than
-		it used to
-	1.30.07 - Kevin
-		Modified the clock to run on timer3 on the Dragonfly. Works with decent accuracy. Using a prescaler of 256
-	the timer counts up to a precomputer value which will trigger an interrupt and reset the timer. Multiples of
-	256 change it by that multiple. Refer to the time.h file for all possible prescalers.
-		The interrupt will call a specified function _rtc_func every pulse.
-		All of it has been tested and it works.	
-		
-	10.29.07 - Andrew
-		Modify to accept multiple functions with different time intervals
-	
+  Change Log:
+  2.5.07 - Kevin
+  Aaron fixed the orb/servo code and made them use timer3 but compare registers B and C. He hard set the prescaler
+  to 8 so the RTC broke. Changed it so that we use a 8 prescaler which sets the compare match at 1/16th of a second.
+  You now count how many 16ths of a second you want until you trigger your actual interrupt. Works. Changed defines
+  for time so you can still call rtc_init with a scale but now it is defined in terms of actual time like second, quarter_second
+  etc. Read that section in the time.h file for more information. Tested and works, though the clock drifts more than
+  it used to
+  1.30.07 - Kevin
+  Modified the clock to run on timer3 on the Dragonfly. Works with decent accuracy. Using a prescaler of 256
+  the timer counts up to a precomputer value which will trigger an interrupt and reset the timer. Multiples of
+  256 change it by that multiple. Refer to the time.h file for all possible prescalers.
+  The interrupt will call a specified function _rtc_func every pulse.
+  All of it has been tested and it works.
 
 */
 #include <avr/interrupt.h>
@@ -29,14 +60,21 @@
 #include <util/delay.h>
 #include <time.h>
 #include <serial.h>
+
+/* Calculate how many cycles to delay for to get 1 ms. Based on F_CPU which should be defined by the makefile */
+#ifdef F_CPU
+#define WAIT_CYCLES ((F_CPU / 1000) / 10)
+#else
+#define WAIT_CYCLES (8000 / 10)
+#endif
 
+static volatile int _rtc_val = 0;
+static volatile int _rtc_pulse = 0;
+static volatile int _rtc_scale = 32;	//Defaults to 1 Second per pulse
+static void (*_rtc_f)(void) = 0;
+
+
 
-
-static volatile int _rtc_val[MAX_FUNCTIONS];
-static volatile int _rtc_pulse[MAX_FUNCTIONS];
-static volatile int _rtc_scale[MAX_FUNCTIONS];
-static int function_count = 0; //Number of functions
-static  void (*_rtc_f[MAX_FUNCTIONS])(void);
 /**
  * @defgroup time Time
  * @brief Time functions
@@ -48,18 +86,28 @@
 
 /**
  * Delays for the specified number of milliseconds.
- * The accuracy of this function is unknown.
+ * It depends on F_CPU to be defined in order to calculate how many cycles
+ * it should delay. If it is not defined, a default clock of 8MHz is assumed.
+ * 
+ * We use _delay_loop_2 which will run assembly instructions that should be
+ * 4 cycles long. Optimizations must be enabled for this to be true.
+ * That function is called to ensure around 1ms per execution. To generate
+ * multiple ms we run a for loop of how many milliseconds are desired.
+ *
+ * The error should be just the skew on the oscillator as the formula to 
+ * calculate delay cycles should always be a whole number. The is some skew
+ * in practice though it is unavoidable. Delaying for less than 1s should make
+ * the error negligable.
  *
  * @param ms the number of milliseconds to delay for
  **/
-void delay_ms(int ms) 
-{
-	for(; ms > 15; ms-=15)
-		_delay_ms(15);
-	_delay_ms(ms);
-}
+void delay_ms(int ms) {
+    for (; ms > 0; ms--) {
+        _delay_loop_2(WAIT_CYCLES);
+    }
+}
+
 
-
 /* 	Prescales defined in time.h. SECOND will give you 1 second.
 	More scales are defined in the time.h file.
 	rtc_func is the address to a function that you want called every clock tick. */
@@ -73,94 +121,40 @@
  * @param rtc_func the function called when the timer is triggered
  *
  * @see rtc_get, rtc_reset
+ *
  **/
- 
- int rtc_multi_init(int* prescale_opt,  void (*rtc_func[])(void), int argc) {
+void rtc_init(int prescale_opt, void (*rtc_func)(void)) {
 	
-	//Check that the number of functions doesn't exceed alloted space
-	if(argc > MAX_FUNCTIONS)
-		return -1;
+  //Clear timer register for Timer 3
+  TCNT3 = 0;
 	
-	function_count = argc;
-	//Clear timer register for Timer 3
-	TCNT3 = 0;
+  /* 	This sets the Waveform Generation Module to CTC (Clear Timer on Compare) Mode (100)
+	See page135 in Atmega128 Docs for more modes and explanations */
+  TCCR3B |= _BV(WGM32);
 	
-	/* 	This sets the Waveform Generation Module to CTC (Clear Timer on Compare) Mode (100)
-		See page135 in Atmega128 Docs for more modes and explanations */
-	TCCR3B |= _BV(WGM32);
+  /* 	This sets the prescaler for the system clock (8MHz) ie: divides the clock by some number.
+	Currently set to a prescaler of 8 because that is what the orb and servos use (they are on this timer as well)
+	See page137 in Atemga128 Docs for all the available prescalers */
+  TCCR3B |= _BV(CS31);
 	
-	/* 	This sets the prescaler for the system clock (8MHz) ie: divides the clock by some number.
-		Currently set to a prescaler of 8 because that is what the orb and servos use (they are on this timer as well)
-		See page137 in Atemga128 Docs for all the available prescalers */
-	TCCR3B |= _BV(CS31);
-	
-	/* 	Sets the two regsiters that we compare against. So the timer counts up to this number and
-		then resets back to 0 and calls the compare match interrupt.
-		8x10^6 / 8 = 1/16 Second. All values are based off of this number. Do not change it unless you
-		are l337*/
+  /* 	Sets the two regsiters that we compare against. So the timer counts up to this number and
+	then resets back to 0 and calls the compare match interrupt.
+	8x10^6 / 8 = 1/16 Second. All values are based off of this number. Do not change it unless you
+	are l337*/
 		
-	OCR3A = 0xF424;	
+  OCR3A = 0xF424;	
 
-	/* 	Enable Output Compare A Interrupt. When OCR3A is met by the timer TCNT3 this interrupt will be
-		triggerd. (See page140 in Atmega128 Docs for more information */
-	ETIMSK |= _BV(OCIE3A);
+  /* 	Enable Output Compare A Interrupt. When OCR3A is met by the timer TCNT3 this interrupt will be
+	triggerd. (See page140 in Atmega128 Docs for more information */
+  ETIMSK |= _BV(OCIE3A);
 	
-
-	/* Set number of functions*/
-	function_count = argc;
+  /*	Store the pointer to the function to be used in the interrupt */
+  _rtc_f = rtc_func;
 	
-	/*	Store how many 1/16ths of a second you want to let by before triggering an interrupt */
-	
-	for (int i = 0; i <argc; i++) {
-		_rtc_pulse[i] = 0;
-		_rtc_val[i] = 0;
-		_rtc_f[i] = rtc_func[i];
-		/*	Store how many 1/16ths of a second you want to let by before triggering an interrupt */
-		_rtc_scale[i] = prescale_opt[i];
-	}
-	return argc-1;
+  /*	Store how many 1/16ths of a second you want to let by before triggering an interrupt */
+  _rtc_scale = prescale_opt;
 }
 
-int rtc_add_function(void (*rtc_func) (void), int prescale_opt)
-{
-	if(function_count>=MAX_FUNCTIONS)
-		return -1;
-	_rtc_f[function_count] = rtc_func;
-	_rtc_pulse[function_count] = 0;
-	_rtc_scale[function_count]  = prescale_opt;
-	//return position in array that function was added to, increment count
-	//this position may change if functions are removed
-	return function_count++;
-}
-
-//remove function pointer
-int rtc_remove_function(void (*rtc_func)(void))
-{
-	for(int i = 0; i < function_count; i++)	
-		if(_rtc_f[i] == rtc_func) {
-			//If not last function replace with last and reduce number of functions
-			if(i < function_count-1) {
-				_rtc_f[i] = _rtc_f[function_count-1];
-				_rtc_pulse[i] = _rtc_pulse[function_count-1];
-				_rtc_scale[i] = _rtc_scale[function_count-1];
-			}
-			return --function_count;
-		}
-	
-	return -1;
-}
-
-int rtc_get_function_count()
-{
-	return function_count;
-}
-
-int rtc_init(int prescale_opt, void (*rtc_func)(void)){
-	int temp[] = {prescale_opt};
-	void (*temp2[MAX_FUNCTIONS])(void) = {rtc_func};
-	return rtc_multi_init(temp, temp2, 1);
-}
-
 /**
  * Returns the time elapsed in seconds since the last call to
  * rtc_init or rtc_reset.
@@ -169,52 +163,39 @@
  *
  * @see rtc_init, rtc_reset
  **/
- 
-int rtc_get(void){
-	return _rtc_val[0];
+int rtc_get(void) {
+  return _rtc_val;
 }
 
-int rtc_get_pos(int pos){
-	return _rtc_val[pos];
-}
-
 /**
  * Resets the real time clock counter to 0.
  *
  * @see rtc_init, rtc_get
  **/
- 
-void rtc_reset(void){
-	_rtc_val[0] = 0;
+void rtc_reset(void) {
+  _rtc_val = 0;
 }
 
-void rtc_reset_all(void)
-{
-	for(int i =0; i < function_count; i++)
-		_rtc_val[i] = 0;
-}
-
 /** @} **/ //end defgroup
 
 /*	Called every pulse. Function in _rtc_f is called every _rtc_scale and also the counter is updated.
 	Bascially, since the pulse is hard set at 1/16s  you want to count how many 16ths of a second have passed
 	and when it reaches the amount of time you want, execute the code. */
+SIGNAL(TIMER3_COMPA_vect) {
 
-SIGNAL(TIMER3_COMPA_vect) {
-	for(int functionNumber = 0; functionNumber < function_count; functionNumber++)
-	{
-		if (_rtc_pulse[functionNumber] ==  _rtc_scale[functionNumber]) {
-			//Increment the real time clock counter
-			_rtc_val[functionNumber]++;
-			
-			//Calls the function tied to the real time clock if defined
-			_rtc_f[functionNumber]();
-			
-			//Resets the pulse until the next scale is matched
-			_rtc_pulse[functionNumber] = 0;
-		}	
-		_rtc_pulse[functionNumber]++;
-	}
-	//Updates the amount of pulses seen since the last scale match
+  if (_rtc_pulse ==  _rtc_scale) {
+    //Increment the real time clock counter
+    _rtc_val++;
+		
+    //Calls the function tied to the real time clock if defined
+    if(_rtc_f != 0)
+      _rtc_f();
+		
+    //Resets the pulse until the next scale is matched
+    _rtc_pulse = 0;
+  }	
 	
+  //Updates the amount of pulses seen since the last scale match
+  _rtc_pulse++;
+	
 }
Index: branches/encoders/code/projects/libdragonfly/spi.h
===================================================================
--- branches/encoders/code/projects/libdragonfly/spi.h	(revision 1344)
+++ branches/encoders/code/projects/libdragonfly/spi.h	(revision 1345)
@@ -4,6 +4,11 @@
  * @author Colony Project, CMU Robotics Club
  **/
 
+/**
+ * @addtogroup spi
+ * @{
+ **/
+
 #ifndef __SPI_H__
 #define __SPI_H__
 
@@ -21,7 +26,21 @@
 typedef void (*spi_fun_recv_t)(char);
 typedef void (*spi_fun_recv_complete_t)(void);
 
+/** 
+* @brief Initialize SPI
+* 
+* @param spi_fun_recv_t The function that handles SPI data, byte for byte.
+* @param spi_fun_recv_complete_t  Called on a completed transmission - typically for cleaning up.
+*/
 void spi_init (spi_fun_recv_t, spi_fun_recv_complete_t);
+
+/** 
+* @brief Initialize SPI transfer.
+* 
+* @param char The number of bytes to transfer.
+*/
 void spi_transfer (char);
 
+/**@}**/ //end group
+
 #endif
Index: branches/encoders/code/projects/libdragonfly/analog.c
===================================================================
--- branches/encoders/code/projects/libdragonfly/analog.c	(revision 1344)
+++ branches/encoders/code/projects/libdragonfly/analog.c	(revision 1345)
@@ -1,156 +1,346 @@
-/*
- * analog.c - Contains the function implementations for manipulating the ADC
- * on the firefly+ board
- * 
- * author:  CMU Robotics Club, Colony Project
- * code mostly taken from fwr analog file (author: Tom Lauwers)
- */
-
-#include <util/delay.h>
-#include <avr/interrupt.h>
-#include "analog.h"
-
-// Internal Function Prototypes
-void set_adc_mux(int which);
-
-/**
- * @defgroup analog Analog
- * Functions for manipulation the ADC on the dragonfly board.
- * All definitions may be found in analog.h.
- *
- * @{
- **/
-
-
-/**
- * Initializes the ADC.
- * Call analog_init before reading from the analog ports.
- *
- * @see analog8, analog10
- **/
-void analog_init(void)
-{
-	// ADC Status Register A
-	// Bit 7 - ADEN is set (enables analog)
-	// Bit 6 - Start conversion bit is set (must be done once for free-running mode)
-	// Bit 5 - Enable Auto Trigger (for free running mode)
-	// Bit 4 - ADC interrupt flag, 0
-	// Bit 3 - Enable ADC Interrupt (required to run free-running mode)
-	// Bits 2-0 - Set to create a clock divisor of 128, to make ADC clock = 8,000,000/128
-	ADCSRA |= 0xEF;
-
-	// ADC Status Register B
-	// Bit 7, 5-3 - Must be cleared
-	// Bit 2:0 - Set mode, currently cleared for free running operation
-	// Bit 6 - Analog comparator mode - cleared
-//	ADCSRB = 0x00;
-	
-	// ADMUX register
-	// Bit 7,6 - Set voltage reference to AVcc (0b01)
-	// Bit 5 - Set ADLAR bit for left adjust to do simple 8-bit reads
-	// Bit 4 - X
-	// Bit 3:0 - Sets the current channel, set to ADC7 (the external mux)
-	ADMUX = 0x67;
-
-	// Set external mux lines to outputs
-	DDRG |= 0x1C;
-	set_adc_mux(0x07);
-}	
-
-
-/**
- * Reads an eight bit number from an analog port.
- * analog_init must be called before using this function.
- * 
- * @param which the analog port to read from. One of
- * the constants AN0 - AN7.
- *
- * @return the eight bit input to the specified port
- *
- * @see analog_init, analog10
- **/
-unsigned int analog8(int which)
-{
-	if(which < EXT_MUX)
-		ADMUX = 0x60 + which;
-	else if(which == EXT_MUX)
-		return 0;
-	else
-	{
-		ADMUX = 0x60 + EXT_MUX;
-		set_adc_mux(which - 8);
-		_delay_ms(1);
-	}
-	
-	_delay_ms(1); // need at least 130 us between conversions
-	return ADCH;
-}
-
-/**
- * Reads a ten bit number from the specified port.
- * analog_init must be called before using this function.
- *
- * @param which the analog port to read from. Typically
- * a constant, one of AN0 - AN7.
- *
- * @return the ten bit number input to the specified port
- * 
- * @see analog_init, analog8
- **/
-unsigned int analog10(int which)
-{
-	unsigned int adc_h = 0;
-	unsigned int adc_l = 0;
-
-	if(which < EXT_MUX)
-		ADMUX = 0x60 + which;
-	else if(which == EXT_MUX)
-		return 0;
-	else
-	{
-		ADMUX = 0x60 + EXT_MUX;
-		set_adc_mux(which - 8);
-		_delay_ms(1);
-	}
-
-	_delay_ms(1);
-	adc_l = ADCL; /* highest 2 bits of ADCL -> least 2 bits of analog val */
-	adc_h = ADCH; /* ADCH -> 8 highest bits of analog val */
-	
-	return (adc_h << 2) | (adc_l >> 6);
-}
-
-/**
- * Returns the current position of the wheel, as an integer
- * in the range 0 - 255.
- * analog_init must be called before using this function.
- *
- * @return the orientation of the wheel, as an integer in
- * the range 0 - 255.
- *
- * @see analog_init
- **/
-int wheel(void)
-{
-	return analog8(WHEEL_PORT);
-}
-
-/**@}**/ //end defgroup
-
-SIGNAL (SIG_ADC)
-{
-	// This is just here to catch ADC interrupts because ADC is free running.  
-	// No code needs to be in here.
-}
-
-void set_adc_mux(int which)
-{
-  // FIX THIS IN NEXT REVISION
-  // ADDR2 ADDR1 ADDR0
-  // G2.G4.G3 set mux to port 0-7 via binary selection
-  // math would be much cleaner if it was G4.G3.G2
-  
-  // mask so only proper bits are possible.  
-  PORTG = (PORTG & 0xE3) | ((which & 0x03) << 3) | (which & 0x04);
-}
-
+/**
+ * Copyright (c) 2007 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+/**
+ * @file analog.c
+ * @brief Analog input and output
+ *
+ * Contains functions for manipulating the ADC on the Dragonfly board.
+ * 
+ * @author Colony Project, CMU Robotics Club
+ * code mostly taken from fwr analog file (author: Tom Lauwers)
+ **/
+
+#include <util/delay.h>
+#include <avr/interrupt.h>
+#include "analog.h"
+#include "serial.h"
+// Internal Function Prototypes
+void set_adc_mux(int which);
+
+/**
+ * @defgroup analog Analog
+ * Functions for manipulation the ADC on the dragonfly board.
+ * All definitions may be found in analog.h.
+ *
+ * @{
+ **/
+
+int adc_loop_running = 0;
+int adc_current_port = 0;
+adc_t an_val[11];
+
+/**
+ * Initializes the ADC.
+ * Call analog_init before reading from the analog ports.
+ *
+ * @see analog8, analog10, analog_get8, analog_get10
+ **/
+void analog_init(int start_conversion) {
+	for (int i = 0; i < 11; i++) {
+		an_val[i].adc10 = 0;
+		an_val[i].adc8 = 0;
+	}
+
+	// ADMUX register
+	// Bit 7,6 - Set voltage reference to AVcc (0b01)
+	// Bit 5 - ADLAR set to simplify moving from register
+	// Bit 4 - X
+	// Bit 3:0 - Sets the current channel
+	// Initializes to read from AN1 first (AN0 is reservered for the BOM)
+	ADMUX = 0;
+	ADMUX |= ADMUX_OPT | _BV(MUX0);
+
+	// ADC Status Register A
+	// Bit 7 - ADEN is set (enables analog)
+	// Bit 6 - Start conversion bit is set (must be done once for free-running mode)
+	// Bit 5 - Enable Auto Trigger (for free running mode) NOT DOING THIS RIGHT NOW
+	// Bit 4 - ADC interrupt flag, 0
+	// Bit 3 - Enable ADC Interrupt (required to run free-running mode)
+	// Bits 2-0 - Set to create a clock divisor of 128, to make ADC clock = 8,000,000/64 = 125kHz
+	ADCSRA = 0;
+	ADCSRA |= _BV(ADEN) | _BV(ADIE) | _BV(ADPS2) | _BV(ADPS1) | _BV(ADPS0);
+	
+	// Set external mux lines to outputs
+	DDRG |= 0x1C;
+	
+	// Set up first port for conversions
+	set_adc_mux(0x00);
+	adc_current_port = AN1;
+
+	//Start the conversion if requested
+	if (start_conversion)
+		analog_start_loop();
+	else
+		analog_stop_loop();
+}	
+
+/**
+ * Returns the 8-bit analog conversion of which from
+ * the lookup table. If the requested port is the BOM_PORT
+ * you will get an automatic 0 since the BOM_PORT is not
+ * read in the loop and not stored. If you need that port
+ * you should use the functions in bom.c. There is an analog_get8
+ * function which for instant lookups but should be avoided unless
+ * you know what you're doing.
+ *
+ * @param which the port that you want to read
+ *
+ * @bug may cause a seg fault if which is a larger value
+ * than exists in an_val table. Not sure if we should fix
+ * this or not since it would add overhead.
+ *
+ * @return 8-bit analog value for the which port requested
+ *
+ * @see analog10, analog_get8, analog_get10
+ **/
+unsigned int analog8(int which) {
+	if (which == BOM_PORT) {
+		return 0;
+	} else {
+		return an_val[which - 1].adc8;
+	}
+}
+
+/**
+ * Returns the 10-bit analog conversion of which from
+ * the lookup table. If the requested port is the BOM_PORT
+ * you will get an automatic 0 since the BOM_PORT is not
+ * read in the loop and not stored. If you need that port
+ * you should use the functions in bom.c. There is an analog_get10
+ * function which for instant lookups but should be avoided unless
+ * you know what you are doing.
+ *
+ * @param which the port that you want to read
+ *
+ * @bug may cause a seg fault if which is a larger value
+ * than exists in an_val table. Not sure if we should fix
+ * this or not since it would add overhead.
+ *
+ * @return 10-bit analog value for the which port requested
+ *
+ * @see analog8, analog_get8, analog_get10
+ **/
+unsigned int analog10(int which) {
+	if (which == BOM_PORT) {
+		return 0;
+	} else {
+		return an_val[which - 1].adc10;
+	}
+}
+
+/**
+ * Starts the analog update loop. Will continue to run
+ * until analog_stop_loop is called.
+ *
+ * @see analog_stop_loop
+ **/
+void analog_start_loop(void) {
+	//Start the conversion
+	ADCSRA |= _BV(ADSC);
+	adc_loop_running = 0x1;
+}
+
+/**
+ * Stops the analog update loop. If there is a current
+ * read, it will finish up and be stored before the loop
+ * is interrupted. No further updates will be made until
+ * the loop is started again.
+ *
+ * @see analog_start_loop
+ **/
+void analog_stop_loop(void) {
+	//Stop the conversion
+	adc_loop_running = 0x0;
+}
+/**
+ * Reads an 8-bit number from an analog port.
+ * analog_init must be called before using this function.
+ * The analog loop must also be stopped before using this
+ * function or you will mess up the lookup table. You
+ * must also reenabled the loop when you are done unless
+ * you are doing more instant reads. See analog_stop_loop
+ * and analog_start_loop for more information about the loop.
+ * 
+ * @param which the analog port to read from. One of
+ * the constants AN0 - AN7.
+ *
+ * @return the 8-bit input to the specified port
+ *
+ * @see analog_init, analog_get10, analog8, analog_stop_loop,
+ * analog_start_loop
+ **/
+unsigned int analog_get8(int which) {	
+	// Let any previous conversion finish
+	while (ADCSRA & _BV(ADSC));
+	
+	if(which < EXT_MUX) {
+		ADMUX = ADMUX_OPT + which;
+	} else {
+		ADMUX = ADMUX_OPT + EXT_MUX;
+		set_adc_mux(which - 8);
+	}
+	
+	// Start the conversion
+	ADCSRA |= _BV(ADSC);
+
+	// Wait for the conversion to finish
+	while (ADCSRA & _BV(ADSC));
+
+	return ADCH; //since we left aligned the data, ADCH is the 8 MSB.
+}
+
+/**
+ * Reads an 10-bit number from an analog port.
+ * analog_init must be called before using this function.
+ * The analog loop must also be stopped before using this
+ * function or you will mess up the lookup table. You
+ * must also reenabled the loop when you are done unless
+ * you are doing more instant reads. See analog_stop_loop
+ * and analog_start_loop for more information about the loop.
+ * 
+ *
+ * @param which the analog port to read from. Typically
+ * a constant, one of AN0 - AN7.
+ *
+ * @return the 10-bit number input to the specified port
+ * 
+ * @see analog_init, analog_get8, analog10, analog_stop_loop,
+ * analog_start_loop
+ **/
+unsigned int analog_get10(int which) {
+	int adc_h;
+	int adc_l;
+	
+	// Let any previous conversion finish
+	while (ADCSRA & _BV(ADSC));
+
+	if(which < EXT_MUX) {
+		ADMUX = ADMUX_OPT + which;
+	} else {
+		ADMUX = ADMUX_OPT + EXT_MUX;
+		set_adc_mux(which - 8);
+	}
+	
+	// Start the conversion
+	ADCSRA |= _BV(ADSC);
+
+	// Wait for the conversion to finish
+	while (ADCSRA & _BV(ADSC));
+	
+	adc_l = ADCL;
+	adc_h = ADCH;
+
+	return ((adc_h << 2) | (adc_l >> 6));
+}
+
+/**
+ * Returns the current position of the wheel, as an integer
+ * in the range 0 - 255.
+ * analog_init must be called before using this function.
+ *
+ * @return the orientation of the wheel, as an integer in
+ * the range 0 - 255.
+ *
+ * @see analog_init
+ **/
+int wheel(void) {
+	return analog8(WHEEL_PORT);
+}
+
+
+/**
+ * Sets the value of the external analog mux. Values are read
+ * 	on AN7 physical port. (AN8 - AN15 are "virtual" ports).
+ *
+ * @param which which analog mux port (0-7) which corresponds
+ * 		  to AN8-AN15.
+ *
+ * @bug FIX THIS IN THE NEXT BOARD REVISION:
+ *		ADDR2 ADDR1 ADDR0
+ *		G2.G4.G3 set mux to port 0-7 via vinary selection
+ *		math would be much cleaner if it was G4.G3.G2
+ *
+ * @see analog_init
+ **/
+void set_adc_mux(int which) {  
+  // mask so only proper bits are possible.  
+  PORTG = (PORTG & 0xE3) | ((which & 0x03) << 3) | (which & 0x04);
+}
+
+/**@}**/ //end defgroup
+
+
+ISR(ADC_vect) {
+	static volatile int adc_prev_loop_running = 0; 
+	int adc_h = 0;
+	int adc_l = 0;
+
+	//Store the value only if this read isn't for the BOM
+	if (ADMUX != BOM_PORT) {
+		adc_l = ADCL;
+		adc_h = ADCH;
+	
+		an_val[adc_current_port - 1].adc10 = (adc_h << 2) | (adc_l >> 6);
+		an_val[adc_current_port - 1].adc8 = adc_h;
+	}
+	
+	//Save the result only if we just turned off the loop
+	if (!adc_loop_running && !adc_prev_loop_running)
+		return;
+	
+	adc_prev_loop_running = adc_loop_running;
+	
+	//Skip AN7 because it is not a real port
+	if (adc_current_port == AN6) {
+		ADMUX = ADMUX_OPT | EXT_MUX;
+		set_adc_mux(AN8 - 8);
+		adc_current_port = AN8;
+	//Wrap around
+	} else if (adc_current_port == AN11) {
+		adc_current_port = AN1;
+		ADMUX = ADMUX_OPT | adc_current_port;
+	//Normal increment
+	} else {
+		adc_current_port++;
+	
+		if(adc_current_port < EXT_MUX) {
+			ADMUX = ADMUX_OPT | adc_current_port;
+		} else {
+			ADMUX = ADMUX_OPT | EXT_MUX;
+			set_adc_mux(adc_current_port - 8);
+		}
+	}
+
+	//Initiate next conversion only if we are running a loop
+	if (!adc_loop_running) {
+		return;
+    } else {
+    	ADCSRA |= _BV(ADSC);
+	}
+		
+	return;
+}
+
Index: branches/encoders/code/projects/libdragonfly/odometry.c
===================================================================
--- branches/encoders/code/projects/libdragonfly/odometry.c	(nonexistent)
+++ branches/encoders/code/projects/libdragonfly/odometry.c	(revision 1345)
@@ -0,0 +1,146 @@
+#include "odometry.h"
+#include <encoders.h>
+#include <math.h>
+#include <avr/interrupt.h>
+#include <dragonfly_lib.h>
+
+long lround(double d);
+
+
+int encoder_ltm1, encoder_rtm1;
+
+//Measure mm displacement in x and y from starting position. (+x:theta=0 +y:theta=M_PI/2)
+long diff_x,diff_y, velocity;
+
+//Measures radian angle displacement from starting position. (initially 0)
+double angle;
+
+/**
+ * Retrieve the estimated x position. [millimeters]
+ */
+long odometry_dx(void){
+	return diff_x;
+}
+
+/**
+ * Retrieve the estimated y position. [millimeters]
+ */
+long odometry_dy(void){
+	return diff_y;
+}
+
+/**
+ * Retrieve the estimated angle [radians]
+ */
+double odometry_angle(void){
+	return angle;
+}
+
+long odometry_velocity(void){
+	return velocity;
+}
+
+/**
+ * Initializes odometry to run on timer 2.
+ * Also resets all values so that the center of the robot is 
+ * considered to be at the origin facing the x direction.
+ */
+void odometry_init(void){
+	
+	encoders_init();
+	
+	delay_ms(100);
+
+	odometry_reset();
+
+	
+	//CTC Mode. CLK / 1024
+	TCCR2 = 0; // (Fully disconnected)
+	TCCR2 = _BV(WGM21) | _BV(CS22) | _BV(CS20); //CLK/1024 , CTC Mode.
+
+	TIMSK |= _BV(OCIE2);
+
+	OCR2 = ODOMETRY_CLK;
+}
+/**
+ * Resets all values so that the center of the robot is 
+ * considered to be at the origin facing the x direction.
+ */
+void odometry_reset(void){
+	diff_x = 0;
+	diff_y = 0;
+	encoder_ltm1 = encoder_read(LEFT);
+	encoder_rtm1 = encoder_read(RIGHT);
+	angle = 0.0;
+}
+
+
+void odometry_run(void){
+	//Angle swept through in a time step CCW-
+	double theta, rl, dc;
+	long dr,dl;
+	char buf[100];
+	
+	//Get the change in wheel positions
+	{	
+		int encoder_right = encoder_read(RIGHT);	
+		int encoder_left = encoder_read(LEFT);	
+	
+		dl = encoder_left - encoder_ltm1;
+		dr = encoder_right - encoder_rtm1;
+		
+		//No motion.
+		if(dl == 0 && dr == 0) return;
+
+		encoder_ltm1 = encoder_left;
+		encoder_rtm1 = encoder_right;
+	
+		// Try to avoid over/underflow.
+		dl = dl > 512 ? dl - 1024 :dl;
+		dl = dl < -512 ? dl + 1024 :dl;
+		dr = dr > 512 ? dr - 1024 :dr;
+		dr = dr < -512 ? dr + 1024 :dr;
+	
+		//Convert "clicks" to um
+		dl *= CLICK_DISTANCE_UM; //um
+		dr *= CLICK_DISTANCE_UM;
+	}
+	
+
+	if(dl == dr){
+		diff_x += lround(dl*cos(angle)/1000.0); //mm
+		diff_y += lround(dl*sin(angle)/1000.0); //mm
+		velocity = lround((dl * 1000.0)/(ODOMETRY_CLK*TIME_SCALE)); //um / ms = mm/s
+		sprintf(buf,"dc: %ld, velocity: %ld\r\n mm/s",dl,velocity);
+		usb_puts(buf);
+		return;
+	}
+	
+	//Call the left wheel 0, clockwise positive.
+	rl = ((double)(ROBOT_WIDTH_UM*dl))/((double)(dl - dr)); //um
+	theta = ((double)(dl - dr))/((double)ROBOT_WIDTH_UM);   //rad
+	
+	//Distance the center has traveled.
+	dc = (theta * (rl - ROBOT_WIDTH_UM)) / 2.0; //um
+	velocity = lround( dc * 1000 /(ODOMETRY_CLK*TIME_SCALE));
+	sprintf(buf,"dc: %lfum, velocity: %ld\r\n mm/s",dc,velocity);
+	usb_puts(buf);
+	
+	//angle is necessarily CCW+, so subtract.
+	angle -= ANGLE_SCALE * theta; 
+	
+	//Change state variables. Probably lose all measurements less then a mm.
+	diff_x += lround((DISTANCE_SCALE * dc * cos(angle))/1000.0); //mm
+	diff_y += lround((DISTANCE_SCALE * dc * sin(angle))/1000.0); //mm
+}
+
+ISR(TIMER2_COMP_vect){
+	odometry_run(); 
+}
+
+long lround(double d){
+	double f = floor(d);
+	return (long)(d - f > 0.5 ? f + 1 : f);
+}
+
+
